#include "definitions.h"
#include "BPMNUnitTask.h"

class OperationNode
{
	
private:

public:

	BPMNUnitTask *task;
	BPMNUnitTask **succs;
	BPMNUnitTask *predLoop;
/*	A node might have many predecessors and successors 
	If the node is an operation, it has at most one predecessor 
	and one successor. Even the successor due to messages are included.
	The difference between theses ones and the other is that the srtTransit[x]
	for a successor due to message x, will not be equal to 0.

	The predecessor connector in case of loop is  not included in **preds.
*/
	BPMNUnitTask *sender;
/* 	A node can be  a receiver sender keep the pointer towards its 
 * sender in this case. Otherwise, sender is null.
*/
	
	BPMNUnitTask *orSplit; /* For all or-join connector, we will keep the id  
	of the corresponding or split.*/
	OperationNode(); 
	~OperationNode();
	void increasePredNumber();
	float *srtTransit; // define this operation and any other element of the graph
/*
	Array of relative and absolute probabilities for 
	successors	
	
*/
	int nloop; // if this is set to more than one, then the task leads to a loop towards
	int loop_starter;
	int succNumber;
	int predNumber;

};


